--TaroNuke's Mod system. Taken from Puuro's 'Hopes And Dreams' file.
--Since this is intended to work on most SM5 versions, I'll use this. -Kid
LoadActor("mods-taro.lua") --Load another lua file.

--For singluar ApplyGameCommands. -Kid
local poptions = {GAMESTATE:GetPlayerState(0):GetPlayerOptions('ModsLevel_Song'),GAMESTATE:GetPlayerState(1):GetPlayerOptions('ModsLevel_Song')}
return Def.ActorFrame{
  Name= "actor_f",
  Def.Quad{
    Name= "actor_g",
    InitCommand= cmd(visible,false),
    OnCommand= cmd(sleep,1000),
  },
  Def.Quad{
    Name= "actor_h",
    InitCommand= cmd(visible,false),
    OnCommand= function(self)
				fgcurcommand = 1;
				checked = false;
				prefix_time = 0;
				
				prefix_curmessage = 1;
				
				--These are for helping scale things to screens. -Kid
				prefix_sdwidth_ratio = (480*(SCREEN_WIDTH/SCREEN_HEIGHT))/640
				prefix_width_ratio = SCREEN_WIDTH/640
				
				prefix_messages = {
					{0,'BlindOn'},--We start off with Blind. -Kid
					{29.096,'BlindOff'},--And then no more Blind. -Kid
					{29.639,'Flash'},
					{29.639,'UnCover'},--This is so we don't have to deal with the hassle that is Cover. -Kid
					{29.639,'ShineOn'},
					{40.843,'Cover'},--Like the Blind MessageCommands I have, we can turn it on and off. -Kid
					{40.934,'ShineOff'},

					{41.205,'Flash'},
					{41.205,'UnCover'},
					{41.205,'ShiningRay'},
					{44.096,'ShiningRay'},
					{52.771,'ShiningRay'},
					{55.663,'ShiningRay'},
					{64.337,'ShiningRay'},
					{67.229,'ShiningRay'},
					{75.904,'ShiningRay'},
					{78.795,'ShiningRay'},

					{99.036,'Flash'},
					{99.036,'Cover'},
				};
				
				
				prefix_mods = {
				--Turned Cover and Blind into MessageCommands. -Kid
				{0,200,'4.5x,*10000 No Beat','end'},--Removed Cover. -Kid

				--{0,29.096,'Blind','end'},

				--{29.639,99.036,'-99999% Cover','end'},

				--{40.843,41.205,'Cover','end'},

				{0.723,27.289,'*0.34584 Centered,*10000 Stealth,*10000 125% Brake,*1.0375 300% Drunk,*0.1729167 -50% Flip','end'},
				{3.615,27.289,'*0.69167 Dark','end'},
				{3.615,27.289,'*10000 100.01% Reverse','end',2},

				{27.289,0.050,'*10000 No Reverse,*10000 No Brake','len'},

				{27.470,240/83/2,'*0.69167 No Centered,*0.69167 No Stealth,*2.075 No Drunk,*0.345834 No Flip','len'},

				{29.277,240/83/8,'*5.53334 Stealth,*5.53334 Dark','len'},
				{29.277+240/83/8,240/83/8,'*10000 No Stealth,*10000 No Dark','len'},
				{29.639,240/83*4,'*10000 0.5% Bumpy,*10000 75% Brake,*10000 Drunk','len'},

				{40.843,240/83/16,'*10000 Stealth,*10000 Dark','len'},
				{40.843+240/83/16,240/83/16,'*10000 No Stealth,*10000 No Dark,*10000 No Bumpy,*10000 No Brake,*10000 No Drunk','len'},

				{43.735,240/83/16,'*5.53334 Brake','len'},
				{43.735+240/83/16,240/83/16,'*5.53334 No Brake','len'},

				{46.265,240/83/4*7,'*2.075 150% Distant,*'..6.91667*prefix_sdwidth_ratio..' '..500*prefix_sdwidth_ratio..'% Bumpy,*10 0.5x,*5.53334 400% Sudden,*10000 -75% SuddenOffset,*2.76667 200% Centered,*0.69167 50% Stealth','len'},
				{46.265+240/83/4*7,240/83/2,'*2.075 No Distant,*'..13.83334*prefix_sdwidth_ratio..' No Bumpy,*10 4.5x,*5.53334 No Sudden,*5.53334 200% SuddenOffset,*2.76667 No Centered,*0.69167 No Stealth','len'},

				{52.410,240/83/16,'*5.53334 Boost','len'},
				{52.410+240/83/16,240/83/16,'*5.53334 No Boost','len'},

				{55.301,240/83/16,'*5.53334 Brake','len'},
				{55.301+240/83/16,240/83/16,'*5.53334 No Brake','len'},

				{57.831,240/83/4*7,'*2.075 150% Distant,*'..6.91667*prefix_sdwidth_ratio..' '..500*prefix_sdwidth_ratio..'% Bumpy,*10 0.5x,*5.53334 400% Sudden,*10000 -75% SuddenOffset,*2.76667 200% Centered,*0.69167 50% Stealth','len'},
				{57.831+240/83/4*7,240/83/2,'*2.075 No Distant,*'..13.83334*prefix_sdwidth_ratio..' No Bumpy,*10 4.5x,*5.53334 No Sudden,*5.53334 200% SuddenOffset,*2.76667 No Centered,*0.69167 No Stealth','len'},

				{66.506,240/83/16*3,'*10000 1000% Sudden, *10000 160% SuddenOffset','len'},--I'd like to not see the arrows racing past the receptors. -Kid
				{66.506,240/83/16,'*11.06667 Split','len'},
				{66.506+240/83/16,240/83/16,'*11.06667 No Split,*11.06667 100.01% Reverse','len'},
				{66.506+240/83/16*2,240/83/16,'*11.06667 No Reverse','len'},
				{66.506+240/83/16*3,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},--Luckilly, these don't happen often here. -Kid

				{69.398,240/83/4*7,'*2.76667 200% Distant,*'..6.91667*prefix_sdwidth_ratio..' '..500*prefix_sdwidth_ratio..'% Bumpy,*10 0.5x,*5.53334 400% Sudden,*10000 -75% SuddenOffset,*5.53334 400% Centered,*0.69167 50% Stealth,*10000 628% Dizzy','len'},
				{69.398+240/83/4*7,240/83/2,'*2.76667 No Distant,*'..13.83334*prefix_sdwidth_ratio..' No Bumpy,*10 4.5x,*5.53334 No Sudden,*5.53334 200% SuddenOffset,*5.53334 No Centered,*0.69167 No Stealth,*10000 No Dizzy','len'},

				{75.542,240/83/16,'*5.53334 Boost','len'},
				{75.542+240/83/16,240/83/16,'*5.53334 No Boost','len'},

				{78.072,240/83/16*3,'*10000 1000% Sudden, *10000 160% SuddenOffset','len'},--Once more. -Kid
				{78.072,240/83/16,'*11.06667 Alternate','len'},
				{78.072+240/83/16,240/83/16,'*11.06667 No Alternate,*11.06667 100.01% Reverse','len'},
				{78.072+240/83/16*2,240/83/16,'*11.06667 No Reverse','len'},
				{78.072+240/83/16*3,0.100,'*10000 no Sudden, *10000 no SuddenOffset','len'},--And we're done. -Kid

				{80.964,240/83/4*7,'*2.76667 200% Distant,*'..6.91667*prefix_sdwidth_ratio..' '..500*prefix_sdwidth_ratio..'% Bumpy,*10 0.5x,*5.53334 400% Sudden,*10000 -75% SuddenOffset,*5.53334 400% Centered,*0.69167 50% Stealth,*10000 628% Dizzy','len'},
				{80.964+240/83/4*7,240/83/2,'*2.76667 No Distant,*'..13.83334*prefix_sdwidth_ratio..' No Bumpy,*10 4.5x,*5.53334 No Sudden,*5.53334 200% SuddenOffset,*5.53334 No Centered,*0.69167 No Stealth,*10000 No Dizzy','len'},

				{86.747,240/83*4,'*4.15 300% Bumpy,*0.69167 50% Drunk,*0.69167 50% Tipsy','len',1},
				{86.747,240/83*4,'*4.15 -300% Bumpy,*0.69167 -50% Drunk,*0.69167 -50% Tipsy','len',2},
				{98.313,240/83*4,'*4.15 No Bumpy,*0.69167 No Drunk,*0.69167 No Tipsy','len'},

				{99.036,200,'*10000 1x,*10000 C88.53334,*10000 300% Drunk,*10000 25% Stealth','end'},

				{99.036,240/83-0.050,'*0.69167 200% Centered','len'},
				{99.036+240/83/4*3,240/83/4-0.050,'*1.4 Stealth,*1.4 Dark','len'},
				{99.036+240/83-0.050,0.050,'*10000 No Centered,*10000 100.01% Reverse','len'},

				{101.928,240/83/4*3,'*1.4 25% Stealth,*1.4 No Dark','len'},
				{101.928,240/83-0.050,'*0.69167 200% Centered,*10000 100.01% Reverse','len'},
				{101.928+240/83/4*3,240/83/4-0.050,'*1.4 Stealth,*1.4 Dark','len'},
				{101.928+240/83-0.050,0.050,'*10000 No Centered,*10000 No Reverse','len'},

				{104.819,240/83/4*3,'*1.4 25% Stealth,*1.4 No Dark','len'},
				{104.819,240/83-0.050,'*0.69167 200% Centered','len'},
				{104.819+240/83/4*3,240/83/4-0.050,'*1.4 Stealth,*1.4 Dark','len'},
				{104.819+240/83-0.050,0.050,'*10000 No Centered,*10000 100.01% Reverse','len'},

				{107.711,240/83/4*3,'*1.4 25% Stealth,*1.4 No Dark','len'},
				{107.711,200,'*0.69167 400% Centered,*10000 100.01% Reverse','end'},
				{107.711+240/83/4*3,200,'*1.4 Stealth,*1.4 Dark','end'},

				}
				
				
				prefix_plr = {};
				
				self:queuecommand('Update');
			end,
    Update2Command= function(self)
		self:sleep(0.02);
		self:queuecommand('Update');
		end,
    UpdateCommand= function(self)
		
			local beat = GAMESTATE:GetSongBeat();
			
			-----------------------
			-- Player mod resets --
			-----------------------
			taronuke_mods("clearall",1)
			taronuke_mods("clearall",2)
			
			--------------------------------------------------------------------------------------------
			-- Mod reader code originally coded by Taronuke, remade to support end times and lengths. --
			--------------------------------------------------------------------------------------------
			for i,v in pairs(prefix_mods) do
				if prefix_time >=v[1] then
					if (v[4] == 'len' and prefix_time <=v[1]+v[2]) or (v[4] == 'end' and prefix_time <=v[2]) then
						if table.getn(v) == 5 then
							taronuke_mods(v[3],v[5])
						else
							for i=1,2 do
							    taronuke_mods(v[3],i)
							end
						end
					end
				end
			end
			
			
			
			if beat >= 0 and not checked then
				
				table.insert(prefix_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP1'));
				table.insert(prefix_plr,SCREENMAN:GetTopScreen():GetChild('PlayerP2'));
				checked = true;
				
				SCREENMAN:GetTopScreen():GetChild('Overlay'):visible(false);
				SCREENMAN:GetTopScreen():GetChild('Underlay'):visible(false);
				--Hide more things. -Kid
				if SCREENMAN:GetTopScreen():GetChild('StageDisplay') then SCREENMAN:GetTopScreen():GetChild('StageDisplay'):visible(false) end
				if SCREENMAN:GetTopScreen():GetChild('SongTitle') then SCREENMAN:GetTopScreen():GetChild('SongTitle'):visible(false) end
				if SCREENMAN:GetTopScreen():GetChild('BPMDisplay') then SCREENMAN:GetTopScreen():GetChild('BPMDisplay'):visible(false) end
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then
						SCREENMAN:GetTopScreen():GetChild('ScoreP'..i):visible(false);
						SCREENMAN:GetTopScreen():GetChild('LifeP'..i):visible(false);
						if SCREENMAN:GetTopScreen():GetChild("SongMeterDisplayP"..i) then SCREENMAN:GetTopScreen():GetChild("SongMeterDisplayP"..i):visible(false) end
						if SCREENMAN:GetTopScreen():GetChild("StepsDisplayP"..i) then SCREENMAN:GetTopScreen():GetChild("StepsDisplayP"..i):visible(false) end
						--Lambda-specific things. -Kid
						if SCREENMAN:GetTopScreen():GetChild("LifeMeterBarP"..i) then SCREENMAN:GetTopScreen():GetChild('LifeMeterBarP'..i):visible(false) end
						
						v:x(SCREEN_CENTER_X);
						v:GetChild('Judgment'):x(160*multi*prefix_sdwidth_ratio):sleep(86.747);--Hold position. -Kid
						v:GetChild('Combo'):x(160*multi*prefix_sdwidth_ratio):sleep(86.747);--And scale it, too. -Kid
						
					end
				end
			end
			
			if beat >= 56 and fgcurcommand == 1 or beat >= 72 and fgcurcommand == 2 or beat >= 88 and fgcurcommand == 3 then
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then
						v:decelerate(240/83/16*3);
						v:rotationz(-30);
						v:decelerate(240/83/16*3);
						v:rotationz(30);
						v:decelerate(240/83/8*3);
						v:rotationz(-360);
						v:sleep(240/83/4);
						v:decelerate(240/83/16*3);
						v:rotationz(-330);
						v:decelerate(240/83/16*3);
						v:rotationz(-390);
						v:decelerate(240/83/8*3);
						v:rotationz(0);
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end

			if beat >= 104 and fgcurcommand == 4 then
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then
						v:decelerate(240/83/16*3);
						v:rotationz(-30);
						v:decelerate(240/83/16*3);
						v:rotationz(30);
						v:decelerate(240/83/8*3);
						v:rotationz(-360);
						v:sleep(240/83/4);
						v:decelerate(240/83/16*3);
						v:rotationz(-330);
						v:decelerate(240/83/16*3);
						v:rotationz(-390);
						v:decelerate(240/83/16*3);
						v:rotationz(-330);
						v:decelerate(240/83/16*3);
						v:rotationz(-720);
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end

			if beat >= 120 and fgcurcommand == 5 then
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then--Consistent positioning. -Kid
						v:GetChild('Judgment'):x(160*multi*prefix_sdwidth_ratio):decelerate(240/83/2);
						v:GetChild('Judgment'):x(0);
						--Also, deal with Lambda's combo tweens. -Kid
						v:GetChild('Combo'):stoptweening():skewy(0):x(160*multi*prefix_sdwidth_ratio):decelerate(240/83/2);
						v:GetChild('Combo'):x(0);
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end

			if beat >= 136 and fgcurcommand == 6 then
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then
						v:x(SCREEN_CENTER_X);
						v:GetChild('Judgment'):x(160*multi*prefix_sdwidth_ratio):sleep(16);--Hold position. -Kid
						--Deal with Lambda's combo tweens. -Kid
						v:GetChild('Combo'):stoptweening():skewy(0):x(160*multi*prefix_sdwidth_ratio):sleep(16);
					end
				end
				fgcurcommand = fgcurcommand + 1;
			end
			
			-------------------------
			-- BEAT SPECIFIC STUFF --
			-------------------------
			if beat >= 56 and beat < 63 or beat >= 72 and beat < 79 or beat >= 88 and beat < 95 or beat >= 104 and beat < 111 then
				--GAMESTATE:ApplyGameCommand('mod,*10000 '..auxvar:getaux() ..'% Distant,*10000 '..auxvar:getaux() ..'% Mini,*10000 '..-auxvar:getaux()/10 ..'% Flip,*10000 '..auxvar:getaux()*2.5 ..'% Bumpy,*10000 '..auxvar:getaux()*5 ..'% Drunk');
				poptions[1]:Distant(auxvar:getaux()/100,10000,true):Mini(auxvar:getaux()/100,10000,true):Flip((-auxvar:getaux()/10)/100,10000,true):Bumpy((auxvar:getaux()*2.5)/100,10000,true):Drunk((auxvar:getaux()*5)/100,10000)
				poptions[2]:Distant(auxvar:getaux()/100,10000,true):Mini(auxvar:getaux()/100,10000,true):Flip((-auxvar:getaux()/10)/100,10000,true):Bumpy((auxvar:getaux()*2.5)/100,10000,true):Drunk((auxvar:getaux()*5)/100,10000)
			end

			if beat >= 120 and beat < 136 then
				for i,v in pairs(prefix_plr) do
					local multi = -1; if i == 2 then multi = 1; end
					if v then--Scale position. -Kid
						v:x(SCREEN_CENTER_X+math.sin(beat*math.pi/4)*160*multi*prefix_width_ratio);
					end
				end
			end
			
			--------------------------------------------------------------
			-- Message reader to make specific values of the actor aux. --
			--------------------------------------------------------------
			if prefix_curmessage <= table.getn(prefix_messages) then
				if prefix_time >= prefix_messages[prefix_curmessage][1] then
					MESSAGEMAN:Broadcast(prefix_messages[prefix_curmessage][2]);
					prefix_curmessage = prefix_curmessage + 1;
				end
			end
			
			self:queuecommand('Update2');
			
		end,
  },
  Def.BitmapText{
    Name= "actor_i",
    Font= "Common Normal",
    OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;effectclock,"music";playcommand,"SetTime";visible,false),
    SetTimeCommand= function(self) self:settext(self:GetSecsIntoEffect()); prefix_time = tonumber(self:GetText()); self:sleep(0.02); self:queuecommand('SetTime'); end,
    Text= "test",
  },
  Def.Quad{
    Name= "actor_j",
    InitCommand= function(self) auxvar = self; self:visible(false) end,
    OnCommand= cmd(),
    ShiningRayMessageCommand= cmd(finishtweening;aux,0;decelerate,240/83/16*3;aux,50;decelerate,240/83/16*3;aux,100;decelerate,240/83/8*3;aux,0),
    --This MessageCommand is for emulating Blind. -Kid
    BlindOnMessageCommand= function(self)
			for i,v in pairs(prefix_plr) do
				if v then
					v:GetChild('Judgment'):visible(false)
					v:GetChild('Combo'):visible(false)
					if v:GetChild('Combo'):GetChild('Number') then
					    v:GetChild('Combo'):GetChild('Number'):visible(false)
					end
				end
			end
		end,
    --This MessageCommand turns off the emulated Blind. -Kid
    BlindOffMessageCommand= function(self)
			for i,v in pairs(prefix_plr) do
				if v then
					v:GetChild('Judgment'):visible(true)
					v:GetChild('Combo'):visible(true)
					if v:GetChild('Combo'):GetChild('Number') then
					    v:GetChild('Combo'):GetChild('Number'):visible(true)
					end
				end
			end
		end,
  },
  Def.ActorFrame{
    Name= "actor_k",
    OnCommand= cmd(fov,20;visible,false),
    ShineOffMessageCommand= cmd(visible,false),
    ShineOnMessageCommand= cmd(visible,true),
    Def.Sprite{
      Name= "actor_l",
      OnCommand= function(self)
			self:customtexturerect(0,0,1,1);
			self:x(SCREEN_CENTER_X);
			self:y(SCREEN_CENTER_Y);
			self:zoomto(SCREEN_WIDTH*2,SCREEN_HEIGHT*2);
			self:ztest(1);
			self:ztestmode('writeonfail'); end,
      ShineOnMessageCommand= function(self)
			self:linear(240/83*4);
			self:rotationz(180); end,
      Texture= "starsmask.png",
    },
  },
  Def.Sprite{
    Name= "actor_m",
    FlashMessageCommand= function(self)
		self:diffusealpha(1);
		self:sleep(0.05);
		self:linear(240/83/8-0.05);
		self:diffusealpha(0); end,
    OnCommand= function(self)
		self:stretchto(0,0,SCREEN_WIDTH,SCREEN_HEIGHT)
		self:diffusealpha(0); end,
    Texture= "whiteflash.png",
  },
}
