return Def.ActorFrame{
  Name= "actor_a",
  Def.ActorFrame{
    Name= "actor_b",
    OnCommand= cmd(),
    Def.Quad{
      Name= "actor_c",
      OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffuse,color('#000000')),
    },
    LoadActor('stars') .. {
      Name= "actor_d",
      File= "stars",
      HideCommand= function(self)
				if prefix_brightness then
					if prefix_brightness > 0 then
						prefix_brightness = prefix_brightness - 2;
						self:diffusealpha(prefix_brightness/100);
						self:sleep(0.02);
						self:queuecommand('Hide');
					end
				end
			end,
      InitCommand= function(self) prefix_stars = self; end,
      OnCommand= cmd(),
      ShowCommand= function(self)
				if prefix_brightness then
					if prefix_brightness < 100 then
						prefix_brightness = prefix_brightness + 2;
						self:diffusealpha(prefix_brightness/100);
						self:sleep(0.02);
						self:queuecommand('Hide');
					end
				end
			end,
    },
  },
  Def.ActorFrame{
    Name= "actor_e",
    Def.Sprite{
      Name= "actor_f",
      OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffusealpha,1;sleep,40;diffusealpha,0;sleep,21;linear,240/180/4;diffusealpha,1;sleep,0;diffusealpha,0;sleep,21.334;diffusealpha,1;sleep,240/180*8;diffusealpha,0;sleep,240/180*16;diffusealpha,1),
      Texture= "blackscreen.png",
    },
    Def.Sprite{
      Name= "actor_g",
      OnCommand= cmd(x,SCREEN_CENTER_X;y,SCREEN_CENTER_Y;zoomtowidth,SCREEN_WIDTH;zoomtoheight,SCREEN_HEIGHT;diffusealpha,0.5;sleep,35.012-0.345;linear,240/180*2;diffusealpha,0),
      Texture= "background.png",
    },
  },
}
